//**************************************************************************
// Ώۃ}CR R8C/38A
// ̧ٓe     ̂ÂReXgdqHg@͉HKgݗăZbg
//              ̂ÂReXgdqHg@o͉HKLbg
//              mFvO
// o[W   Ver.1.01
// Date         2016.02.01
// Copyright    ГhLg\[VY
//**************************************************************************

//======================================
// CN[h
//======================================
#include "sfr_r838a.h"                  // R8C/38A SFR̒`t@C

//======================================
// V{`
//======================================
// 3IN^[uڂ̉K
#define         DO_3        38226       // h
#define         DOU_3       36081       // h
#define         RE_3        34056       // 
#define         REU_3       32144       // 
#define         MI_3        30340       // ~
#define         FA_3        28637       // t@
#define         FAU_3       27030       // t@
#define         SO_3        25513       // \
#define         SOU_3       24081       // \
#define         RA_3        22729       // 
#define         RAU_3       21454       // 
#define         SI_3        20250       // V

// 4IN^[uڂ̉K
#define         DO_4        19113       // h
#define         DOU_4       18040       // h
#define         RE_4        17028       // 
#define         REU_4       16072       // 
#define         MI_4        15170       // ~
#define         FA_4        14319       // t@
#define         FAU_4       13515       // t@
#define         SO_4        12756       // \
#define         SOU_4       12041       // \
#define         RA_4        11365       // 
#define         RAU_4       10727       // 
#define         SI_4        10125       // V

// 5IN^[uڂ̉K
#define         DO_5        9557        // h
#define         DOU_5       9020        // h
#define         RE_5        8514        // 
#define         REU_5       8036        // 
#define         MI_5        7585        // ~
#define         FA_5        7159        // t@
#define         FAU_5       6758        // t@
#define         SO_5        6378        // \
#define         SOU_5       6020        // \
#define         RA_5        5682        // 
#define         RAU_5       5363        // 
#define         SI_5        5062        // V

// tJ[LED
#define         GREEN       4           // ΂̓_rbg
#define         BLUE        2           // ̓_rbg
#define         RED         1           // Ԃ̓_rbg

// seg_leftseg_rightϐɓl
#define SEG_NULL            16          // 7ZO 
#define SEG_DP              0x80        // 7ZO DP\

//======================================
// vg^Cv錾
//======================================
void init( void );
void timer( unsigned long timer_set );
void beep( unsigned int tone );
void led( int color );

//======================================
// O[oϐ̐錾
//======================================
unsigned long cnt_rb;                   // ^C}RBp

////////////////////////////////////////////////////////////////
// 7ZOgLED

const unsigned char seg_data[] = {      // 7ZOgLED̕\f[^
    0b00111111,                         //  0 = 0
    0b00000110,                         //  1 = 1
    0b01011011,                         //  2 = 2
    0b01001111,                         //  3 = 3
    0b01100110,                         //  4 = 4
    0b01101101,                         //  5 = 5
    0b01111101,                         //  6 = 6
    0b00100111,                         //  7 = 7
    0b01111111,                         //  8 = 8
    0b01101111,                         //  9 = 9
    0b01110111,                         // 10 = A
    0b01111100,                         // 11 = b
    0b00111001,                         // 12 = C
    0b01011110,                         // 13 = d
    0b01111001,                         // 14 = E
    0b01110001,                         // 15 = F
    0b00000000,                         // 16 = 
};

int seg_left  = SEG_NULL;               // ̌@\l
int seg_right = SEG_NULL;               // Ě@\l
int seg_digit;                          // 0:\ 1:E\

////////////////////////////////////////////////////////////////
// DC[^
int dcm;                                // -10`10 0:~ 10:100%
int dcm_comp;                           // ]邩rp

////////////////////////////////////////////////////////////////
// XebsO[^̗㎥o͐M 1㎥
// bit3=D(/B) bit2=C(/A) bit1=B bit0=A
const signed char stm_data[] = {
    0b00000001,                         // 0 A㎥
    0b00000010,                         // 1 B㎥
    0b00000100,                         // 2 /A㎥
    0b00001000,                         // 3 /B㎥
};

int stm;                                // 0:~ :vŒl[ms]Ƃɗ㎥
                                        // :vŒl[ms]Ƃɗ㎥ 1͒E
int stm_step_cnt;                       // 삵Xebv 2001]
int stm_comp;                           // ㎥RC؂ւԊu
int stm_dim;                            // ㎥o͐M̓Y

//**********************************************************************
// CvO
//**********************************************************************
void main( void )
{
    int i;

    init();                             // 
    asm(" fset I ");                    // Ŝ̊荞݋

    while( 1 ) {
        switch( p1 & 0x0f ) {   // DIP SW
        case 1:                 // tJ[LED̊mF
            led( GREEN );
            timer( 1000 );
            led( BLUE );
            timer( 1000 );
            led( RED );
            timer( 1000 );
            led( 0 );
            timer( 1000 );
            break;

        case 2:                 // 7ZOgLED̊mF
            for( i=0; i<10; i++ ) {
                seg_left  = i;              // ̌@_
                seg_right = SEG_NULL;       // Ě@
                timer( 1000 );
            }
            seg_left  = SEG_NULL | SEG_DP;  // ̌@hbg_
            seg_right = SEG_NULL;           // Ě@
            timer( 1000 );

            for( i=0; i<10; i++ ) {
                seg_left  = SEG_NULL;       // ̌@
                seg_right = i;              // Ě@_
                timer( 1000 );
            }
            seg_left  = SEG_NULL;           // ̌@
            seg_right = SEG_NULL | SEG_DP;  // Ě@hbg_
            timer( 1000 );
            break;

        case 4:                 // dTE_[̊mF
            beep( DO_3 );
            timer( 500 );
            beep( RE_3 );
            timer( 500 );
            beep( MI_3 );
            timer( 500 );
            beep( FA_3 );
            timer( 500 );
            beep( SO_3 );
            timer( 500 );
            beep( RA_3 );
            timer( 500 );
            beep( SI_3 );
            timer( 500 );
            beep( DO_4 );
            timer( 500 );
            beep( 0 );
            timer( 500 );
            break;

        case 8:                 // DC[^̊mF
            seg_left  = 0;
            seg_right = 1;
            dcm = 5;                    // 50%̗
            timer( 1000 );
            dcm = 0;                    // ~
            timer( 1000 );
            dcm = 10;                   // 100%̗
            timer( 1000 );
            dcm = 0;                    // ~
            timer( 1000 );

            seg_left  = 1;
            seg_right = 0;
            dcm = -5;                   // -50%̗
            timer( 1000 );
            dcm = 0;                    // ~
            timer( 1000 );
            dcm = -10;                  // -100%̗
            timer( 1000 );
            dcm = 0;                    // ~
            timer( 1000 );

            seg_left  = SEG_NULL;
            seg_right = SEG_NULL;
            break;

        case 9:                 // XebsO[^̊mF
            seg_left  = 1;
            seg_right = 0;
            stm       = 5;              // 5msƂɎv1Xebv㎥
            timer( 3000 );

            seg_left  = SEG_NULL;
            seg_right = SEG_NULL;
            stm       = 0;
            timer( 500 );

            seg_left  = 0;
            seg_right = 1;
            stm       = -5;             // 5msƂɔv1Xebv㎥
            timer( 3000 );

            seg_left  = SEG_NULL;
            seg_right = SEG_NULL;
            stm       = 0;
            timer( 500 );
            break;

        case 11:                // ͉HK̐M͂̊mF
            i = 0;
            if( p9_0 ) i |= BLUE;       // tHgC^v^̊mF
            if( p9_1 ) i |= GREEN;      // gOXCb`̊mF
            if( p9_2 ) i |= RED;        // ^NgXCb`̊mF

            led( i );
            break;
        }
    }
}

//**********************************************************************
// R8C/38A XyVt@NVWX^(SFR)̏
//**********************************************************************
void init( void )
{
    int i;

    // NbNXINNbN(20MHz)ɕύX
    prc0  = 1;                          // veNg
    cm13  = 1;                          // P4_6,P4_7XIN-XOUT[qɂ
    cm05  = 0;                          // XINNbNU
    for(i=0; i<50; i++ );               // 肷܂ŏ҂(10ms)
    ocd2  = 0;                          // VXeNbNXINɂ
    prc0  = 0;                          // veNgON

    // |[g̏o
    p0 = 0xe0;                          // LEDADC[^~ 7ZO

    // |[g̓o͐ݒ
    prc2 = 1;                           // PD0̃veNg
    pd0 = 0xff;                         //
    pd2 = 0xff;                         // 7-0:LED
    pur0 = 0x04;                        // P1_3`P1_0̃vAbvON

    // ^C}RB̐ݒ
    // 荞ݎ = 1 / 20[MHz]    * (TRBPRE+1) * (TRBPR+1)
    //              = 1 / (20*10^-6) * 200        * 100
    //              = 0.001[s] = 1[ms]
    trbmr  = 0x00;                      // 샂[hAݒ
    trbpre = 200-1;                     // vXP[WX^
    trbpr  = 100-1;                     // vC}WX^
    trbic  = 0x07;                      // 荞ݗD惌xݒ
    trbcr  = 0x01;                      // JEgJn

    // ^C}RC PWM[hݒ
//  trcpsr1 = 0x03;                     // TRCIOC[q=P0_7(d)
    pwmc_trcmr = 1;                     // TRCIOCPWM[h
    trccr1  = 0xa0;                     // JEg\[X,o͂̐ݒ
    trcgra  = 0;                        // ݒ
    trcgrc  = 0;                        // ONݒ
    ec_trcoer = 0;                      // TROIOCo͋
}

//**********************************************************************
// ^C}RB 荞ݏ(1msƂɎs)
//**********************************************************************
#pragma interrupt intTRB(vect=24)
void intTRB( void )
{
    // JE^̃CNg
    cnt_rb++;

    // DC[^
    if( dcm == 0 ) {
        // u[L
        p0_4 = 0;
        p0_3 = 0;
    } else if( dcm > 0 ) {
        // ]
        dcm_comp++;
        if( dcm_comp >= 10 ) dcm_comp = 0;
        if( dcm_comp < dcm ) {
            p0_4 = 0;
            p0_3 = 1;
        } else {
            p0_4 = 0;
            p0_3 = 0;
        }
    } else {
        // t]
        dcm_comp++;
        if( dcm_comp >= 10 ) dcm_comp = 0;
        if( dcm_comp < (-dcm) ) {
            p0_4 = 1;
            p0_3 = 0;
        } else {
            p0_4 = 0;
            p0_3 = 0;
        }
    }

    // XebsO[^𐧌䂷邽߂ɁAʐ7ZO͏
    p0_2 = 0;                           // 7ZO
    p0_1 = 0;                           // 7ZOE

    // XebsO[^̐
    if( stm == 0 ) {
        // ~A
        stm_comp = 0;
        p2 = 0x00;
        // XebsO[^֏o
        p0_0 = 1;                       // CK HIGH
        p0_0 = 0;                       // CK LOW
    } else if( stm > 0 ) {
        // v
        stm_comp++;
        if( stm_comp >= stm ) {         //㎥قւԊůmF
            stm_comp = 0;
            stm_dim++;                  // ㎥RC̐؂ւ
            if( stm_dim > 3 ) stm_dim = 0;
            p2 = stm_data[ stm_dim ];   // ㎥f[^Zbg
            stm_step_cnt++;             // Xebv𑝂₷
            // XebsO[^֏o
            p0_0 = 1;                   // CK HIGH
            p0_0 = 0;                   // CK LOW
        }
    } else {
        // v
        stm_comp++;
        if( stm_comp >= (-stm) ) {      //㎥قւԊůmF
            stm_comp = 0;
            stm_dim--;                  // ㎥RC̐؂ւ
            if( stm_dim < 0 ) stm_dim = 3;
            p2 = stm_data[ stm_dim ];   // ㎥f[^Zbg
            stm_step_cnt--;             // Xebv炷
            // XebsO[^֏o
            p0_0 = 1;                   // CK HIGH
            p0_0 = 0;                   // CK LOW
        }
    }


    // 7ZOgLED̕\@ƉĚ݂ɕ\
    if( seg_digit == 0 ) {              // \Ȃ
        // E\
        seg_digit = 1;
        p2   = seg_data[ seg_right & 0x7f ];        // l̃Zbg
        if( seg_right & SEG_DP ) p2 |= SEG_DP;      // DP̕\
        p0_2 = 1;                                   // EON
    } else {
        // \
        seg_digit = 0;
        p2   = seg_data[ seg_left & 0x7f ];         // l̃Zbg
        if( seg_left & SEG_DP ) p2 |= SEG_DP;       // DP̕\
        p0_1 = 1;                                   // ON
    }
}

//**********************************************************************
// ^C}{
// @ ^C}l 1=1ms
//**********************************************************************
void timer( unsigned long timer_set )
{
    cnt_rb = 0;
    while( cnt_rb < timer_set );
}

//**********************************************************************
// uU[炷
// @KPWMl
//**********************************************************************
void beep( unsigned int tone )
{
    if( tone ) {
        tstart_trcmr = 0;               // TRC̃JEg~
        trc     = tone - 1;
        trcgra  = tone - 1;             // ݒ
        trcgrc  = tone / 2 - 1;         // ONݒ
        trcpsr1 = 0x03;                 // TRCIOC[q=P0_7(d)
        tstart_trcmr = 1;               // TRC̃JEgJn
    } else {
        tstart_trcmr = 0;               // TRC̃JEg~
        trcpsr1 = 0x00;                 // TRCIOC[q=
    }
}

//**********************************************************************
// tJ[LED炷
// @bit2:΁Abit1FAbit0:  "0"= "1"=_
//**********************************************************************
void led( int color )
{
    // ΐFLED
    if( color & GREEN ) p0_7 = 0;
    else                p0_7 = 1;

    // FLED
    if( color & BLUE  ) p0_6 = 0;
    else                p0_6 = 1;

    // ԐFLED
    if( color & RED   ) p0_5 = 0;
    else                p0_5 = 1;
}

//**********************************************************************
// end of file
//**********************************************************************
